//---------------------------------------------------------------------------

#include <windows.h>
#include "lpc10.h"
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

static int c__180 = 180;
static int c__10 = 10;

extern struct {
    int order, lframe;
    short corrp;
} contrl_;


#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
        return 1;
}
//---------------------------------------------------------------------------

extern __declspec(dllexport)
struct lpc10_encoder_state *
create_lpc10_encoder_state()
{
    struct lpc10_encoder_state *st;

    st = (struct lpc10_encoder_state *)
	malloc((unsigned) sizeof (struct lpc10_encoder_state));
    if (st != 0) {
	init_lpc10_encoder_state(st);
    }
    return (st);
}

extern __declspec(dllexport)
struct lpc10_decoder_state *
create_lpc10_decoder_state()
{
    struct lpc10_decoder_state *st;

    st = (struct lpc10_decoder_state *)
	malloc((unsigned) sizeof (struct lpc10_decoder_state));
    if (st != 0) {
	init_lpc10_decoder_state(st);
    }
    return (st);
}

extern __declspec(dllexport)   int lpc10_decode(int *bits, float *speech,
				  struct lpc10_decoder_state *st)
{
    int irms, voice[2], pitch, ipitv;
    extern int decode_(int *, int *, int *,  int *, int *, float *, float *, struct lpc10_decoder_state *);
    float rc[10];
    extern int chanrd_(int *, int *, int *, int *, int *),
            synths_(int *, int *, float *, float *, float *, int *, struct lpc10_decoder_state *);
    int irc[10], len;
    float rms;

/*   LPC Configuration parameters: */
/* Frame size, Prediction order, Pitch period */
/*       Arguments */
/*   LPC Processing control variables: */

/* *** Read-only: initialized in setup */



    /* Function Body */

    chanrd_(&c__10, &ipitv, &irms, irc, &bits[0]);
    decode_(&ipitv, &irms, irc, voice, &pitch, &rms, rc, st);
    synths_(voice, &pitch, &rms, rc, &speech[0], &len, st);
    return 0;
} /* lpcdec_ */

extern __declspec(dllexport)   int lpc10_encode(float *speech, int *bits,
				  struct lpc10_encoder_state *st)
{
    int irms, voice[2], pitch, ipitv;
    float rc[10];
    extern int encode_(int *, int *, float *, float *, int *, int *, int *),
               chanwr_(int *, int *, int *, int *, int *, struct lpc10_encoder_state *),
               analys_(float *, int *, int *, float *, float *, struct lpc10_encoder_state *),
               prepro_(float *, int *, struct lpc10_encoder_state *);
    int irc[10];
    float rms;

/*       Arguments */
/*   LPC Configuration parameters: */
/* Frame size, Prediction order, Pitch period */
/*       Local variables that need not be saved */
/*       Uncoded speech parameters */
/*       Coded speech parameters */
/*       Local state */
/*       None */

    /* Function Body */
    prepro_(&speech[0], &c__180, st);
    analys_(&speech[0], voice, &pitch, &rms, rc, st);
    encode_(voice, &pitch, &rms, rc, &ipitv, &irms, irc);
    chanwr_(&c__10, &ipitv, &irms, irc, &bits[0], st);
    return 0;
} /* lpcenc_ */