#define LPC10_SAMPLES_PER_FRAME 180
#define LPC10_BITS_IN_COMPRESSED_FRAME 54
typedef char *address;
typedef struct { float r, i; } complex;
typedef struct { double r, i; } doublecomplex;

#define TRUE_ (1)
#define FALSE_ (0)

#define abs(x) ((x) >= 0 ? (x) : -(x))
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))

struct lpc10_encoder_state {
    /* State used only by function hp100 */
    float z11;
    float z21;
    float z12;
    float z22;

    /* State used by function analys */
    float inbuf[540], pebuf[540];
    float lpbuf[696], ivbuf[312];
    float bias;
    int osbuf[10];  /* no initial value necessary */
    int osptr;     /* initial value 1 */
    int obound[3];
    int vwin[6]	/* was [2][3] */;   /* initial value vwin[4] = 307; vwin[5] = 462; */
    int awin[6]	/* was [2][3] */;   /* initial value awin[4] = 307; awin[5] = 462; */
    int voibuf[8]	/* was [2][4] */;
    float rmsbuf[3];
    float rcbuf[30]	/* was [10][3] */;
    float zpre;


    /* State used by function onset */
    float n;
    float d__;   /* initial value 1.f */
    float fpc;   /* no initial value necessary */
    float l2buf[16];
    float l2sum1;
    int l2ptr1;   /* initial value 1 */
    int l2ptr2;   /* initial value 9 */
    int lasti;    /* no initial value necessary */
    short hyst;   /* initial value FALSE_ */

    /* State used by function voicin */
    float dither;   /* initial value 20.f */
    float snr;
    float maxmin;
    float voice[6]	/* was [2][3] */;   /* initial value is probably unnecessary */
    int lbve, lbue, fbve, fbue;
    int ofbue, sfbue;
    int olbue, slbue;
    /* Initial values:
	lbve = 3000;
	fbve = 3000;
	fbue = 187;
	ofbue = 187;
	sfbue = 187;
	lbue = 93;
	olbue = 93;
	slbue = 93;
	snr = (float) (fbve / fbue << 6);
	*/

    /* State used by function dyptrk */
    float s[60];
    int p[120]	/* was [60][2] */;
    int ipoint;
    float alphax;

    /* State used by function chanwr */
    int isync;

};


struct lpc10_decoder_state {

    /* State used by function decode */
    int iptold;   /* initial value 60 */
    short first;   /* initial value TRUE_ */
    int ivp2h;
    int iovoic;
    int iavgp;   /* initial value 60 */
    int erate;
    int drc[30]	/* was [3][10] */;
    int dpit[3];
    int drms[3];

    /* State used by function synths */
    float buf[360];
    int buflen;   /* initial value 180 */

    /* State used by function pitsyn */
    int ivoico;   /* no initial value necessary as long as first_pitsyn is initially TRUE_ */
    int ipito;   /* no initial value necessary as long as first_pitsyn is initially TRUE_ */
    float rmso;   /* initial value 1.f */
    float rco[10];   /* no initial value necessary as long as first_pitsyn is initially TRUE_ */
    int jsamp;   /* no initial value necessary as long as first_pitsyn is initially TRUE_ */
    short first_pitsyn;   /* initial value TRUE_ */

    /* State used by function bsynz */
    int ipo;
    float exc[166];
    float exc2[166];
    float lpi1;
    float lpi2;
    float lpi3;
    float hpi1;
    float hpi2;
    float hpi3;
    float rmso_bsynz;

    /* State used by function random */
    int j;   /* initial value 2 */
    int k;   /* initial value 5 */
    short y[5];  /* initial value { -21161,-8478,30892,-10216,16950 } */

    /* State used by function deemp */
    float dei1;
    float dei2;
    float deo1;
    float deo2;
    float deo3;

};

